#include "fileio.ch"
procedure main
#if .f.
   local cFileName := "DAT4GB.txt"
   local nSizeExPl := 4154687701
   local cSizeExPl := "  4.154.687.701"
#endif
#if .t.
   local cFileName := "DAT8GB.txt"
   local nSizeExPl := 8309375402
   local cSizeExPl := "  8.309.375.402"
#endif
#if .f.
   local cFileName := "DAT80GB.txt"
   local nSizeExPl := 8309375402*10
   local cSizeExPl := " 83.093.754.020"
#endif
   local nZiel, nBytes, x, nBytesToWrite, nWrittenBytes
   local nDauer

   cls

   delete file (cFileName)  // sicher ist sicher

   nBytes  := 4096
   cBuffer := replicate("A",nBytes)
   nBytesToWrite := nSizeExPl
   nWrittenBytes  := 0

   ?
   ? "Make VeryBig.TXT"
   ? cFileName
   ? "Gewnschte Gre:    ", transform(nSizeExPl,"999,999,999,999"), " (numerisch)"
   ? "Gewnschte Gre:    ", cSizeExPl, " (string)"
   ? "Startzeit:           ", time()
   ?

   nDauer  := seconds()
   nZiel   := FCreate( cFileName, FC_NORMAL )

   IF nZiel == -1
      ? "Fehler beim Erzeugen der Datei:", FError()
   ELSE
      x             := 1
      do while nBytesToWrite > 0
         if x > 100
            @ row(), 0 say "Geschriebene Bytes:   "+transform(nWrittenBytes, "999,999,999,999")
            x := 1
         else
            x++
         endif
         if nBytesToWrite < nBytes  // nicht mehr schreiben als gewnscht
            nBytes := nBytesToWrite
         endif
         nBytes := FWrite(nZiel, @cBuffer, nBytes)
         nBytesToWrite -= nBytes
         nWrittenBytes += nBytes
         if FError() > 0
            ? "SCHREIBEN - FError() = ",FError()
            exit
         endif
      enddo
   ENDIF

   FClose( nZiel )

   nDauer  := seconds() - nDauer
   ?
   ?
   ? "Ende mit Close:      ", time()

   ? "Ergebnis:"
   ? "Gewnschte Gre:    ", transform(nSizeExPl,"999,999,999,999"), " (numerisch)"
   ? "Gewnschte Gre:    ", cSizeExPl, " (string)"
   ? "Geschriebene Bytes:  ", transform(nWrittenBytes,"999,999,999,999"), " (gezhlt)"
   ? "Tatschliche Gre:  ", transform(FSize(cFileName),"999,999,999,999"), " (FSize())"
   ? "Dauer:   ", ntrim(int(nDauer/60)) , "Minuten", ntrim(nDauer % 60) , "Sekunden.   Geschwindigkeit: ",alltrim(transform(nWrittenBytes/1024/nDauer,"999,999")),"MByte/Sekunde"

   wait
return
*----------------------------------------------------
function ntrim(n)
return alltrim(str(n))

